program ic(input, output);
(* ic: inches to cm

  Tom Schneider
  toms@alum.mit.edu
  https://alum.mit.edu/www/toms/


 *)

label 1; (* end of program *)

const
(* begin module version *)
version = 1.00; (* of ic.p 1996 July 31
origin 1996 Jul 31 *)
(* end module version *)

(* begin module describe.ic *)
(*
name
   ic: inches to cm

synopsis
   ic(input: out, output: out)

files
   input:  user gives inch values
       End with a blank line.
   output: program converts and gives corresponding cm values

description
   Xyplo has converted to cm from inches.  To make the
   conversion of xyplop files easier, this program lets
   the user give inches and get cm values.

examples

documentation

see also
   xyplo.p

author
   Thomas Dana Schneider

bugs

technical notes

*)
(* end module describe.ic *)

(* begin module halt *)
procedure halt;
(* stop the program.  the procedure performs a goto to the end of the
   program.  you must have a label:
      label 1;
   declared, and also the end of the program must have this label:
      1: end.
   examples are in the module libraries.
   this is the only goto in the delila system. *)
begin
      writeln(output,' program halt.');
      goto 1
end;
(* end module halt version = 'delmod 6.16 84 mar 12 tds/gds'; *)

(* begin module ic.themain *)
procedure themain;
(* the main procedure of the program *)
var
  cm: real; (* cm measurement *)
  inches: real; (* inch measurement *)
begin
   writeln(output,'ic ',version:4:2);
   writeln(output, 'give inch values to get cm');
   while not eoln(input) do begin
      readln(input, inches);
      cm := inches*2.54;
      writeln(output, 'for inches = ',inches:8:5,' cm =',cm:8:5);
   end;
end;
(* end module ic.themain *)

begin
   themain;
1: end.
