program ll(input,output);
(* ll: line lengths

  Thomas D. Schneider, Ph.D.
  toms@alum.mit.edu
  toms@alum.mit.edu (permanent)
  https://alum.mit.edu/www/toms (permanent)

   *)

const
(* begin module version *)
   version = 1.04; (* of ll.p 2010 Jul 30
2010 Jul 30, 1.04: remove extra spaces on output
1991 Mar 23, 1.03: functional
origin 1986 april 15 *)
(* end module version *)

(* begin module describe.ll *)
(*
name
   ll: line lengths

synopsis
   ll(input: in, output: out)

files
   input: the source of the lines
   output: the length of each line

description
   The lengths of lines in the input file are given to the output file.
   A useful way to use the program is to find the longest length line in
   the file using the Unix sort routine:
       ll < myfile | sort | tail -1

see also
   Unix sort routine, flag.p.

author
   Thomas D. Schneider

bugs
   none known

*)
(* end module describe.ll *)

(* begin module themain *)
procedure themain(var a, b: text);
(* main procedure of the program.
find the lengths of lines in file a and report them in b *)
var
   count: integer;
begin
(*   rewrite(b);*)
   while not eof(a) do begin
      count := 0;
      while not eoln(a) do begin
         count := count + 1;
         get(a);
      end;
      readln(a);
      writeln(b,count:1);
   end
end;
(* end module themain *)

begin
   themain(input,output);
end.
