program shortline(input,output);
(* shortline: make short lines out of long lines
   Tom Schneider, 1991 *)

const
(* begin module version *)
version = 1.00; (* of shortline.p 1991 Oct 4
origin 1991 Oct 4 from ww 1.01 1988 Sep 14
(* end module version *)

(* begin module describe.shortline *)
(*
name
   shortline: make short lines out of long lines

synopsis
   shortline(input: in, output: out)

files
   input:  text to be wrapped
   output: wrapped text

description
   This Pascal program takes ASCII text and filters it.  Lines longer than the
constant maxline are forced to be maxline long by inserting carriage returns.

author
   Thomas Dana Schneider

bugs
   the constant maxline is fixed at compile time, of course.

*)
(* end module describe.shortline *)

    maxline = 70; (* maximum width of output lines *)

var c: char; (* a character in the input *)
    n: integer; (* number of characters written to output so far *)
begin
  while not eof(input) do begin
    n := 0; (* no characters written out so far on this line *)
    while not eoln(input) do begin
      read(input,c);
      if n > maxline then begin 
         writeln(output); (* insert the carriage return *)
         n := 0; (* no characters written out so far on this line *)
      end
      else begin
        write(output,c);
        n := n + 1;
      end
    end;

    readln(input);
    writeln(output);
  end
end.
